/*
   Copyright 2008-2015 Genentech Inc.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/
package com.genentech.oechem.tools;

import openeye.oechem.OEBondBase;
import openeye.oechem.OEUnaryBondBoolFunc;
import openeye.oechem.OEUnaryBondPred;

/**
 * An OpenEye functor which can be used eg. in for loops to find bonds of a 
 * specific order.
 * 
 * @author albertgo
 *
 */
public class BondIsChiralFunctor extends OEUnaryBondPred {

   public BondIsChiralFunctor() {
   }
   

   @Override
   public boolean constCall(OEBondBase bd) {
      return ( bd.IsChiral() ) ;
   }
   
   @Override
   public OEUnaryBondBoolFunc CreateCopy( ) {
      OEUnaryBondBoolFunc copy = new BondIsChiralFunctor();
      copy.swigReleaseOwnership();
      return copy;
   }
}
