/*
<parameters>
   <parameter name='#SCHEME#' />
   <parameter name='#seqName#' />
   <parameter name='#seqComment#' />
   
   <parameter name='#dropTableSQL#'
            replaceRE='/\*Start #dropTableSQL#\*/(.+?)/\*End #dropTableSQL#\*/' >    
      <parameter name='#TABLE#' />
   </parameter>
   
   <parameter name='#createTableSQL#'
            replaceRE='/\*Start #createTableSQL#\*/(.+?)/\*End #createTableSQL#\*/' >    
      <parameter name='#TABLE#' />
      <parameter name='#tblComment#' />
      <parameter name='#column#'
               replaceRE='/\*Start #column#\*/(.+?)/\*End #column#\*/'>
         <parameter name='#colName#' />
         <parameter name='#dataType#' />
         <parameter name='#constraint#' />
      </parameter>
      
      <parameter name='#colSQL#'
               replaceRE='/\*Start #colSQL#\*/(.+?)/\*End #colSQL#\*/' >
         <parameter name='#colName#' />
         <parameter name='#colCommentSQL#'
                  replaceRE='/\*Start #colCommentSQL#\*/(.+?)/\*End #colCommentSQL#\*/'>
            <parameter name='#columnComment#' />
         </parameter>
         
         <parameter name='#indexSQL#'
                  replaceRE='/\*Start #indexSQL#\*/(.+?)/\*End #indexSQL#\*/'>
            <parameter name='#unique#' />
            <parameter name='#indexID#' />
         </parameter>
         
         <parameter name='#primKeySQL#'
                  replaceRE='/\*Start #primKeySQL#\*/(.+?)/\*End #primKeySQL#\*/'>
            <parameter name='#primKeyID#' />
         </parameter>
         
         <parameter name='#foreignKeySQL#'
                  replaceRE='/\*Start #foreignKeySQL#\*/(.+?)/\*End #foreignKeySQL#\*/'>
            <parameter name='#foreignKeyID#' />
            <parameter name='#refTable#' />
            <parameter name='#refCol#' />
         </parameter>
      </parameter>
   </parameter>
</parameters>  
*/


--CREATE SCHEMA #SCHEME#;
--DROP SCHEMA #SCHEME# CASCADE;

--Introducing this function allows the SQLs for query saving to be compatible 
--to ORACLE and Postgres.
-- drop function #SCHEME#.fil_nextval();
create or replace function #SCHEME#.fil_nextval()
   returns bigint  as $$
DECLARE
   retval bigint := nextVal('#SCHEME#.seq_#seqName#');
BEGIN
   return retVal;
END;
$$  LANGUAGE plpgsql Volatile;

--DROP SEQUENCE #SCHEME#.seq_#seqName#;
   
/*Start #dropTableSQL#*/
--DROP TABLE #SCHEME#.#TABLE#;
/*End #dropTableSQL#*/

 
   CREATE SEQUENCE #SCHEME#.seq_#seqName#
      INCREMENT 1
      START 1
      CACHE 10;
   COMMENT ON SEQUENCE #SCHEME#.seq_#seqName# IS '#seqComment#';


/*Start #createTableSQL#*/
   CREATE TABLE #SCHEME#.#TABLE#
   (	
/*Start #column#*/      #colName# #dataType# #constraint#   /*End #column#*/
   )
   WITHOUT OIDS;

   COMMENT ON TABLE #SCHEME#.#TABLE# IS '#tblComment#';


   /*Start #colSQL#*/
      /*Start #colCommentSQL#*/
   COMMENT ON COLUMN #SCHEME#.#TABLE#.#colName# IS '#columnComment#';
      /*End #colCommentSQL#*/
      
      /*Start #indexSQL#*/
   CREATE #unique# INDEX idx_#indexID# ON #SCHEME#.#TABLE#(#colName#);
      /*End #indexSQL#*/
      
      /*Start #primKeySQL#*/
   ALTER TABLE #SCHEME#.#TABLE# ADD CONSTRAINT pk_#primKeyID# PRIMARY KEY (#colName#);
      /*End #primKeySQL#*/
      
      /*Start #foreignKeySQL#*/
   ALTER TABLE #SCHEME#.#TABLE# ADD CONSTRAINT fk_#foreignKeyID#
         FOREIGN KEY (#colName#) REFERENCES #SCHEME#.#refTable# (#refCol#) DEFERRABLE;
      /*End #foreignKeySQL#*/
      
   /*End #colSQL#*/
   
/*End #createTableSQL#*/


